/* Free a pointer in a signal handler and
   conventionally; */
#include <stdlib.h>
#include <signal.h>

char *string;

void handler(int no)
{
  free(string);
}

int main()
{
  struct sigaction action;
  sigset_t block_usr1;

  /* Set a handler for SIGUSR1 */
  action.sa_handler = handler;
  action.sa_flags = 0x0;
  sigemptyset(&action.sa_mask);
  sigaction(SIGUSR1, &action, NULL);

  /* Block SIGUSR1 */
  sigemptyset(&block_usr1);
  sigaddset(&block_usr1, SIGUSR1);
  sigprocmask(SIG_BLOCK, &block_usr1, NULL);

  string = malloc(1000);

  /* Raise signal and wait for it to finish */
  sigfillset(&block_usr1);
  sigdelset(&block_usr1, SIGUSR1);
  raise(SIGUSR1);
  sigsuspend(&block_usr1);
  
  /* Perform double free */
  free(string);
  return 0;
}
